﻿init python:
    import random
    import time
    random.seed(time.perf_counter_ns())
    class reward_items:
        def __init__(self, name, image):
            self.name = name
            self.image = image
    class reward_class:
        def __init__(self, items, delay):
            self.items = items
            self.delay = delay
            self.is_open = False
        def open(self):
            self.is_open = True

screen reward(loot, delay):
    modal True
    default g = reward_class(loot, delay)
    timer g.delay action Function(g.open)
    add "star_shine" align .5,.5 yoffset 250 at reward_star(2)
    add "star_shine" align .5,.5 yoffset 250 at reward_star(4)
    add "star_shine" align .5,.5 yoffset 250 at reward_star(6)
    fixed fit_first True:
        align .5,.8
        if g.is_open:
            add "chest_popped"
        else:
            add "chest_shaking"
    if len(g.items)%2:
        default positions = [
            (0, -450),
            (-200, -400),
            (200, -400),
            (340, -250),
            (-340, -250),
        ]
    else:
        default positions = [
            (-110, -420),
            (110, -420),
            (290, -300),
            (-290, -300),
        ]
    for p, i in zip(positions, g.items):
        add i.image align .5,.7 at reward_item_animation(g.delay, p)

    button:
        align .5,.65 padding 20,20 background "#0009"
        at reward_item_animation(g.delay+1, (0,0))
        text "Take all"
        action Return(g.items)


transform reward_star(t):
    linear t rotate 359 zoom (random.random()*2)+1 additive 1
    rotate 0
    repeat
transform reward_item_animation(d, p):
    alpha 0 xoffset p[0]/4
    parallel:
        pause d
        easein_elastic 2 alpha 1
    parallel:
        pause d+.05
        easein_elastic 2 offset p



image chest_popped:
    "open_chest"
    ease .05 yoffset -40
    ease .2 yoffset 0
image chest_shaking:
    "closed_chest"
    rotate_pad False
    parallel:
        ease .1 rotate 2
        ease .1 rotate -2
        repeat

default all_reward_items = [
    "axe_hammer",
    "cake",
    "cheese",
    "crock_pumpkin",
    "cycolate",
    "death_pill",
    "dunno",
    "epic_flail",
    "golden",
    "golden_axe",
    "golden_mace",
    "good_hammer",
    "nicknack",
    "one_sided_wrench",
    "parts",
    "rare_pickaxe",
    "real_meat",
    "red_meat",
    "red_wrench",
    "short_axe",
    "the_thing",
    "unhandy_axe",
    "white_box",
    "worm_meal",
    ]

label reward_example:
    show bg room with dissolve
    menu:
        "Buy a cheap lootbox.":
            $ num = random.randint(1,3)
        "Buy a normal lootbox.":
            $ num = random.randint(2,4)
        "Buy an expensive lootbox.":
            $ num = random.randint(3,5)
    python:
        loot = []
        for i in range(num):
            # Choose your rewards (Ideally using loot tables)
            j = random.choice(all_reward_items)

            # I'm using a dummy item class
            # you should modify the code to use your inventory
            item = reward_items(j, j)

            loot.append(item)

    call screen reward(loot, 2)
    $ num  = len(_return)
    "You've got [num] items."
    jump reward_example

